<template>
  <section view="player" class="pv-container">
    <header class="pv-search">
      <input
        type="search"
        class="pv-search__input"
        placeholder="Find radios"
        v-model="searchValue"
        autofocus
        maxlenght=100
        minlength=3>
    </header>
    <div class="pv-stations">
      <div
        v-for="station in filteredStations"
        :key="station.url"
        class="pv-stations__item">
        <span role="flag" :class="['flag-icon', `flag-icon-${station.code.toLowerCase()}`]" />
        <div role="title" class="title">
          {{ station.title }}
        </div>
        <div role="country" class="country">
          {{ station.subtitle }}
        </div>
        <span
          role="playing"
          :class="[isStationPlaying(station)]"
          @click.stop="handlePlay(station)" />
      </div>
    </div>
    <footer v-if="selectedStation" class="pv-player">
      <span role="flag" :class="['flag-icon', `flag-icon-${selectedStation.code.toLowerCase()}`]" />
      <div role="title">
        {{ get(selectedStation, 'title', '') }}
      </div>
      <div role="country">
        {{ get(selectedStation, 'subtitle', '') }}
      </div>
      <span role="add" class="gg-play-list-add" />
      <audio role="player" controls ref="$player" />
    </footer>
  </section>
</template>

<script>
import get from 'lodash/get';
import { onMounted, computed, ref, nextTick } from 'vue';
import { useStore } from 'vuex';
import 'flag-icon-css/css/flag-icon.min.css';
import 'css.gg/icons/css/play-button.css';
import 'css.gg/icons/css/play-pause.css';
import 'css.gg/icons/css/play-list-remove.css';
import 'css.gg/icons/css/play-list-add.css';

export default {
  name: 'Player',
  setup() {
    const { dispatch, state } = useStore();
    const selectedStation = ref(null);
    const API_HOST = 'http://radio.garden/api';
    const searchValue = ref('');
    const $player = ref(null);
    const filteredStations = computed(() => {
      if (!searchValue.value) return state.player.stations;
      return state.player.stations
        .filter(radio => radio.title.toLowerCase().includes(searchValue.value.toLowerCase()));
    });
    const buildRadioUrl = channelId => `${API_HOST}/ara/content/listen/${channelId}/channel.mp3`;

    onMounted(() => {
      dispatch('player/doListStations');
    });

    const isStationPlaying = station => (selectedStation.value
      && selectedStation.value.url === station.url
      ? 'gg-play-pause'
      : 'gg-play-button');

    const isStationAdded = station => (state.player.stations
      .some(radio => radio.url === station.url)
      ? 'gg-play-list-add'
      : 'gg-play-list-remove');

    const handlePlay = async station => {
      selectedStation.value = station;
      await nextTick();
      $player.value.src = buildRadioUrl(selectedStation.value.channelId);
      $player.value.load();
      $player.value.play();
    };

    return {
      get,
      filteredStations,
      selectedStation,
      searchValue,
      isStationPlaying,
      isStationAdded,
      handlePlay,
      $player,
    };
  },
};
</script>

<style lang="scss" scoped>
.pv-container {
  display: grid;
  grid-template-rows: min-content 1fr min-content;
  height: 100%;
  width: 100%;
  max-width: 512px;
}
.pv-search {
  padding: .4rem;
  &__input {
    width: 100%;
    padding: .4rem;
    font-size: 1.5rem;
    border: solid 1px $color-border;
    color: #1673c7;
    background-color: white;
    box-sizing: border-box;
    border-radius: 8px;
    margin-top: 8px;
    appearance: none;
    &:focus {
      outline: none;
      border-color: #6bace6;
    }
  }
}
.pv-stations {
  height: 97%;
  overflow-y: auto;
  display: grid;
  grid-template-rows: min-content;
  grid-auto-rows: min-content;
  grid-row-gap: .3rem;
  padding: .4rem;
  &__item {
    display: grid;
    grid-template-rows: min-content min-content;
    grid-template-columns: 2rem 1fr 2rem;
    align-items: center;
    border: solid 1px;
    box-sizing: border-box;
    border-radius: 8px;
    border-radius: 8px;
    grid-column-gap: .4rem;
    padding: .4rem 0;
    [role="flag"] {
      grid-column: 1;
      grid-row: 1/3;
      width: 100%;
    }
    [role="title"] {
      grid-column: 2;
      grid-row: 1;
      font-size: 1.5rem;
    }
    [role="country"] {
      grid-row: 2;
      grid-column: 2;
      align-self: start;
    }
    [role="playing"] {
      grid-column: 3;
      grid-row: 1/3;
    }
  }
}
.pv-player {
  display: grid;
  grid-template-rows: repeat(3, min-content);
  grid-template-columns: 2rem 1fr 2rem 2rem;
  align-items: center;
  box-sizing: border-box;
  grid-column-gap: 0.4rem;
  padding: 0.4rem;
  box-shadow: -1px -4px 5px 0px #ebeaea;
  [role="flag"] {
    grid-column: 1;
    grid-row: 1/3;
    width: 100%;
  }
  [role="title"] {
    grid-column: 2;
    grid-row: 1;
    font-size: 1.5rem;
  }
  [role="country"] {
    grid-row: 2;
    grid-column: 2;
    align-self: start;
  }
  [role="add"] {
    grid-column: 3;
    grid-row: 1/3;
  }
  [role="player"] {
    margin-top: 1rem;
    grid-column: 1/5;
    grid-row: 3;
    width: 100%;
  }
}
</style>
